package cn.iocoder.yudao.module.member.service.orderdetail;

import cn.iocoder.yudao.framework.common.pojo.PageResult;
import cn.iocoder.yudao.module.member.controller.admin.screen.vo.DishVO;
import cn.iocoder.yudao.module.member.controller.app.orderdetail.vo.AppOrderDetailPageReqVO;
import cn.iocoder.yudao.module.member.controller.app.orderdetail.vo.AppOrderDetailRespVO;
import cn.iocoder.yudao.module.member.controller.app.orderdetail.vo.AppOrderDetailSaveReqVO;
import cn.iocoder.yudao.module.member.dal.dataobject.orderdetail.OrderDetailDO;

import javax.validation.Valid;
import java.util.List;

/**
 * 订单明细 Service 接口
 *
 * @author 开发账号
 */
public interface OrderDetailService {

    /**
     * 创建订单明细
     *
     * @param createReqVO 创建信息
     * @return 编号
     */
    Long createOrderDetail(@Valid AppOrderDetailSaveReqVO createReqVO);

    /**
     * 更新订单明细
     *
     * @param updateReqVO 更新信息
     */
    void updateOrderDetail(@Valid AppOrderDetailSaveReqVO updateReqVO);

    /**
     * 删除订单明细
     *
     * @param id 编号
     */
    void deleteOrderDetail(Long id);

    /**
     * 获得订单明细
     *
     * @param id 编号
     * @return 订单明细
     */
    OrderDetailDO getOrderDetail(Long id);

    /**
     * 获得订单明细分页
     *
     * @param pageReqVO 分页查询
     * @return 订单明细分页
     */
    PageResult<OrderDetailDO> getOrderDetailPage(AppOrderDetailPageReqVO pageReqVO);

    List<AppOrderDetailRespVO> selectListByOrderId(Long orderId);

    List<OrderDetailDO> selectListByOrderIds(List<Long> orderIds);

    List<DishVO>  selectDishSale(Long storeId);
}